﻿Type=Class
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
#Event: ValueChanged(Value As Double,UserChanged As Boolean)
#Event: Released(Value As Double)

' Class to manage input sliders (similar to Seekbar) that allows use of images
Private Sub Class_Globals
	Private CommonName As String = "InputSlider"
	Private PtrPos As Double
	Private BarBGOrient As Boolean			' True = Vertical False = Horizontal
	Private MaxVal,MinVal As Double
	Private MaxMove As Int
	Private BarBG As Panel
	Private Ptr As Panel
	Private Version As String
	Private mTarget As Object
    Private mEventName As String
	Private mAct As Activity
	Private mBase As Panel
	Private DesignerCVCalled As Boolean
	Private Initialized,VHiLo As Boolean
	Private mTag As Object
	Private mUserChanged As Boolean
	Private mSteps As Int = 0
End Sub
'Initializes the object. You can add parameters to this method if needed.
'Initializes the object.
'Required for both designer and code setup. 
'Provides callback {EventName}_ItemClick(Position As Int,Value As Object)
Public Sub Initialize (TargetModule As Object, EventName As String)
	mTarget = TargetModule
	mEventName = EventName
	Version = "1.01"
End Sub
Public Sub DesignerCreateView(Base As Panel, Lbl As Label, Props As Map)
	'Check this is not called from setup
	If Not(Props.GetDefault("SLfromsetup",False)) Then DesignerCVCalled = True
	
	'Assign vars to globals
	mBase = Base
	'This is passed from either the designer or setup
	mAct = Props.get("activity")
	
	mBase.Color = Colors.Transparent
	
	'Initialize Panels
	BarBG.Initialize("BarBG")
	Ptr.Initialize("Ptr")
	
	'Set default colours for panels, allows testing without loading images
	'BarBG.Color=Colors.Blue
	'Ptr.Color=Colors.Yellow
	
	'Set orientation
	If mBase.Width >= mBase.Height Then BarBGOrient = False Else BarBGOrient = True
	
	mBase.AddView(BarBG,0,0,mBase.Width,mBase.Height)
	
	'Initialize ptr size based on Orientation
	If BarBGOrient Then
		BarBG.AddView(Ptr,0,0,BarBG.Width,BarBG.Width)
		'Load default images if they are in the assets folder
		If File.Exists(File.DirAssets,"sliderbgv.png") Then 
			setBackGroundImage(LoadBitmap(File.DirAssets,"sliderbgv.png"))
		Else 
			If File.Exists(File.DirAssets,"sliderbgv.png") Then 
				setBackGroundImage(LoadBitmap(File.DirAssets,"sliderbgv.png"))
			End If
		End If
		If File.Exists(File.DirAssets,"sliderbtn.png") Then	setPointerImage(LoadBitmap(File.DirAssets,"sliderbtn.png"))
	Else
		BarBG.AddView(Ptr,0,0,BarBG.Height,BarBG.Height)
		'Load default images if they are in the assets folder
		If File.Exists(File.DirAssets,"sliderbg.png") Then 
			setBackGroundImage(LoadBitmap(File.DirAssets,"sliderbg.png"))
		Else
			If File.Exists(File.DirAssets,"sliderbg.png") Then 
				setBackGroundImage(LoadBitmap(File.DirAssets,"sliderbg.png"))
			End If
		End If
		If File.Exists(File.DirAssets,"sliderbtn.png") Then	setPointerImage(LoadBitmap(File.DirAssets,"sliderbtn.png"))
	End If
	
	'Default Initializations
	PtrPos = 0
	If BarBGOrient Then
		setmaxmovev
		MaxVal = MaxMove
	Else
		setmaxmoveh
		MaxVal = MaxMove
	End If
	
	MovePtr(0.5)
	
	mTag = Base.Tag
	
	'Finally
	Initialized = True
End Sub

'Manual Setup of InputSlider Pass Null as Panel if adding to activity
Sub Setup(Act As Activity,Pnl As Panel,Left As Int,Top As Int,Width As Int,Height As Int)

	'Check if DesignerCreateView has been called
	If DesignerCVCalled Then
		LogColor(CommonName & ": You should not call setup if you have defined this view in the designer",Colors.Red)
		Return
	End If
	
	mAct = Act
	
	'Create our own base panel
	Dim Base As Panel
	Base.Initialize("")
	
	'If Null was passed, a Panel wii be created by casting, but it won't be initialized
	If Pnl.IsInitialized Then
		Pnl.AddView(Base,Left,Top,Width,Height)
	Else
		Act.AddView(Base,Left,Top,Width,Height)
	End If
		
	'Set up vars to pass to DesignerCreateView so we don't have to maintain two identical subs
	Dim M As Map
	M.Initialize
	M.Put("activity",mAct)
	'As we are passing a map, we can use it to pass an additional flag for our own use 
	'with an ID unlikely To be used by B4a In the future
	M.Put("SLfromsetup",True)
	
	'We need a label to pass to DesignerCreateView
	Dim L As Label
	L.Initialize("")
	'Default text size
	'Default size for custom view text in designer is 14
	'Default For a Spinner Is 16, I didn't want to enforce this as you wouldn't then be able to change the size in the designer
	'and a default SLSpinner added in designer would look different to one added in code.
	L.TextSize = 14						
	L.Typeface = Typeface.DEFAULT
	L.Gravity = Gravity.CENTER_VERTICAL
	'Leave TextColor as default. Color is write only so we can't copy it, don't bother setting it
	
	DesignerCreateView(Base,L,M)

End Sub
'Set size of the Bar Background, -1 leaves parameter as is
Sub SetBarBGSize(Left As Int,Top As Int,Width As Int,Height As Int)
	If Left <> -1 Then mBase.Left=Left
	If Top <> -1 Then mBase.Top=Top
	If Width <> -1 Then 
		mBase.Width=Width
		If BarBGOrient = False Then setmaxmoveh
	End If
	If Height <> -1 Then 
		mBase.Height=Height
		If BarBGOrient Then setmaxmovev
	End If
	BarBG.SetLayout(mBase.Left,mBase.Top,mBase.Width,mBase.Height)
End Sub
'Set size of the Pointer Background, -1 leaves parameter as is
Sub setPtrSize(Left As Int,Top As Int,Width As Int,Height As Int)
	If Left <> -1 Then Ptr.Left=Left
	If Top <> -1 Then Ptr.Top=Top
	If Width <> -1 Then 
		Ptr.Width=Width
		If BarBGOrient = False Then setmaxmoveh
	End If
	If Height <> -1 Then 
		Ptr.Height=Height
		If BarBGOrient Then setmaxmovev
	End If
End Sub
Sub getPointerWidth As Int
	Return Ptr.Width
End Sub
'Set Bar background image as BitmapDrawable
Sub setBackGroundImage(Image As Bitmap)
	BarBG.setBackGroundImage(Image)
End Sub
Sub setVerticalHiLo(VHL As Boolean)
	VHiLo = VHL
End Sub
'Set Pointer background Image as BitmapDrawable
Sub setPointerImage(Image As Bitmap)
	Ptr.setBackGroundImage(Image)
End Sub
'Set Max Value
Sub setMax(sMaxVal As Double)
	MaxVal=sMaxVal
End Sub
Sub getMax As Double
	Return MaxVal
End Sub
'Set Min Value
Sub setMin(sMinVal As Double)
	MinVal = sMinVal
End Sub
Sub setSteps(Steps As Int)
	mSteps = Abs(Steps)
End Sub
Sub getSteps As Int
	Return mSteps
End Sub
'Set Current Position (0 - 1) 
Sub setPos(sValue As Double)
	If Not(mBase.Enabled) Then Return
	PtrPos=sValue
	MovePtr(PtrPos)
End Sub
Private Sub BarBG_touch (Action As Int, X As Float, Y As Float)
	mUserChanged = True
	If Action = 0 Then
		If BarBGOrient Then
			MovePtr(Min(Max(0,Y *(MaxMove/BarBG.Height)),MaxMove)/MaxMove)
		Else
			'BarBG is horizontal
			MovePtr(Min(Max(0,X *(MaxMove/BarBG.Width)),MaxMove)/MaxMove)
		End If
	End If
	If Action = 1 Then
		If SubExists(mTarget,mEventName&"_Released") Then
			CallSub2(mTarget,mEventName&"_Released",getValue)
				mUserChanged = False
			Return
		End If
		mUserChanged = False
	End If
	If Action = 2 Then
		
		If BarBGOrient Then
			
			MovePtr(Min(Max(0,Y *(MaxMove/BarBG.Height)),MaxMove)/MaxMove)
		Else
			'BarBG is horizontal
			
			MovePtr(Min(Max(0,X *(MaxMove/BarBG.Width)),MaxMove)/MaxMove)
		End If
		
	End If
	
End Sub
Private Sub MovePtr(Pos As Double)
	PtrPos = Pos
	If mSteps > 0 Then
		Dim StepVal As Double = 1 / mSteps
		Dim NoSteps As Int = Round(PtrPos / StepVal)
		PtrPos = NoSteps * StepVal
		Log(PtrPos)
	End If
	If BarBGOrient Then
		Ptr.Top = PtrPos * MaxMove
	Else
		Ptr.Left = PtrPos * MaxMove
	End If
	
	'Check for call back subs and call if available
	If SubExists(mTarget,mEventName & "_ValueChanged") Then
			CallSub3(mTarget,mEventName & "_ValueChanged",getValue,mUserChanged)
	End If
	
	If SubExists(mTarget,mEventName & "_PosChanged") Then
			CallSub3(mTarget,mEventName & "_PosChanged",PtrPos,mUserChanged)
	End If
End Sub
'Get the calculated value from the InputSlider
Sub getValue As Double
	If BarBGOrient And VHiLo Then
		Return MaxVal - (PtrPos * (MaxVal - MinVal))
	Else
		Return MinVal + (PtrPos * (MaxVal - MinVal))
	End If
End Sub
'Set Current Value *** Set Max value first	
Sub setValue (sPos As Double)
	sPos = Min(sPos,MaxVal)
	sPos = Max(sPos,MinVal)
	'If the user is currently changing the value the don't allow updates
	If mUserChanged Then Return
	If VHiLo Then
		PtrPos = 1 - (sPos - MinVal) / (MaxVal - MinVal)
	Else
		PtrPos = (sPos - MinVal) / (MaxVal - MinVal)
	End If
	MovePtr(PtrPos)
End Sub
'Returns position as float range 0-1
Sub getPos As Float
	Return PtrPos
End Sub
Sub IsInitialized As Boolean
	Return Initialized
End Sub
Private Sub setmaxmovev
	'Determine maximum move allowed
	MaxMove=BarBG.Height-Ptr.Height
End Sub
Private Sub setmaxmoveh
	'Determine maximum move allowed
	MaxMove=BarBG.Width-Ptr.Width
End Sub
Sub getVersion As String
	Return Version
End Sub
Sub setTag(Obj As Object)
	mTag = Obj
End Sub
Sub getTag As Object
	Return mTag
End Sub
'Get or Set the background for the Base Panel. Can be one of: BitmapDrawable, ColorDrawable, GradientDrawable or StateListDrawable
'Returns a drawable of the type that was initially or subsequently set
Sub setBackgroundDrawable(BG As Object)
	If Not(BG Is BitmapDrawable Or BG Is GradientDrawable Or BG Is StateListDrawable) Then
		LogColor(CommonName & ": setBackground failed : Not a drawable Object",Colors.Red)
		Return
	End If
	mBase.Background = BG
End Sub
Sub getBackgroundDrawable As Object
	Return mBase.Background
End Sub
Sub setBackgroundDrawable2(Color As Int,Radius As Int)
	Dim CD As ColorDrawable
	CD.Initialize(Color,Radius)
	setBackgroundDrawable(CD)
End Sub
Sub setBackgroundPnlColor(Color As Int)
	mBase.Color = Color
End Sub
Sub setVisible(Visible As Boolean)
	mBase.Visible = Visible
End Sub
Sub getVisible As Boolean
	Return mBase.Visible
End Sub
Sub setTop(Top As Int)
	mBase.Top = Top
End Sub
Sub getLeft As Int
	Return mBase.Left
End Sub
Sub setLeft(Left As Int)
	mBase.Left = Left
End Sub
Sub getTop As Int
	Return mBase.Top
End Sub
Sub getHeight As Int
	Return mBase.Height
End Sub
Sub getWidth As Int
	Return mBase.Width
End Sub
Sub setHeight(Height As Int)
	mBase.Height = Height
End Sub
Sub setWidth(width As Int)
	mBase.width = width
End Sub
Sub setEnabled(Enabled As Boolean)
	mBase.Enabled = Enabled
End Sub
Sub getEnabled As Boolean
	Return mBase.Enabled
End Sub